 config.guess                   |    8 
 config.sub                     |   22 -
 configure                      |  462 +++++++++++++++------
 misc/autotroll/config.guess    |  888 +++++++++++++++++++----------------------
 misc/autotroll/config.sub      |  431 ++++++++++++++-----
 misc/m4/qt.m4                  |    2 
 misc/m4/qt5.m4                 |   78 ++-
 misc/m4/tm_gui.m4              |    8 
 misc/tm-devel-mac/config.guess |  856 ++++++++++++++++++---------------------
 packages/debian/rules          |   14 
 10 files changed, 1572 insertions(+), 1197 deletions(-)


diff --git a/src/misc/m4/qt.m4 b/src/misc/m4/qt.m4
index 0fec408a1..c5136373d 100644
--- a/src/misc/m4/qt.m4
+++ b/src/misc/m4/qt.m4
@@ -19,7 +19,7 @@ AC_DEFUN([LC_WITH_QT],[
 QT5_AVAILABLE="no"
 SAVE_LIBS="$LIBS"
 LIBS=""
-#     AX_HAVE_QT
+AX_HAVE_QT
 LIBS="$SAVE_LIBS"
 if test x"$have_qt" = xyes; then 
   AC_MSG_RESULT([Qt5 found])
diff --git a/src/misc/m4/qt5.m4 b/src/misc/m4/qt5.m4
index 44cbcaeaa..e85dc8aa1 100644
--- a/src/misc/m4/qt5.m4
+++ b/src/misc/m4/qt5.m4
@@ -53,7 +53,7 @@
 #   and this notice are preserved. This file is offered as-is, without any
 #   warranty.
 
-#serial 12
+#serial 13 + additions added by Karl Hegbloom trying to fix it. :-)
 
 AU_ALIAS([BNV_HAVE_QT], [AX_HAVE_QT])
 AC_DEFUN([AX_HAVE_QT],
@@ -71,43 +71,73 @@ AC_DEFUN([AX_HAVE_QT],
     am_have_qt_pro=`mktemp`
     am_have_qt_makefile=`mktemp`
     # http://qt-project.org/doc/qt-5/qmake-variable-reference.html#qt
+    # the below list is not complete because I do not have every module installed on my laptop ~karlheg
     cat > $am_have_qt_pro << EOF
-qtHaveModule(axcontainer):       QT += axcontainer
-qtHaveModule(axserver):          QT += axserver
-qtHaveModule(concurrent):        QT += concurrent
+dnl qtHaveModule(3dcore):            QT += 3dcore
+dnl qtHaveModule(3dextras):          QT += 3dextras
+dnl qtHaveModule(3dinput):           QT += 3dinput
+dnl qtHaveModule(3dlogic):           QT += 3dlogic
+dnl qtHaveModule(3dquick):           QT += 3dquick
+dnl qtHaveModule(3dquickextras):     QT += 3dquickextras
+dnl qtHaveModule(3dquickinput):      QT += 3dquickinput
+dnl qtHaveModule(3dquickrender):     QT += 3dquickrender
+dnl qtHaveModule(3drender):          QT += 3drender
+dnl qtHaveModule(axcontainer):       QT += axcontainer
+dnl qtHaveModule(axserver):          QT += axserver
+dnl qtHaveModule(concurrent):        QT += concurrent
+dnl qtHaveModule(contacts):          QT += contacts
 qtHaveModule(core):              QT += core
 qtHaveModule(dbus):              QT += dbus
-qtHaveModule(declarative):       QT += declarative
-qtHaveModule(designer):          QT += designer
+dnl qtHaveModule(declarative):       QT += declarative
+dnl qtHaveModule(designer):          QT += designer
+dnl qtHaveModule(feedback):          QT += feedback
 qtHaveModule(gui):               QT += gui
 qtHaveModule(help):              QT += help
-qtHaveModule(multimedia):        QT += multimedia
-qtHaveModule(multimediawidgets): QT += multimediawidgets
+dnl qtHaveModule(location):          QT += location
+dnl qtHaveModule(multimedia):        QT += multimedia
+dnl qtHaveModule(multimediawidgets): QT += multimediawidgets
 qtHaveModule(network):           QT += network
-qtHaveModule(opengl):            QT += opengl
+dnl qtHaveModule(opengl):            QT += opengl
+dnl qtHaveModule(openglextensions):  QT += openglextensions
+dnl qtHaveModule(organizer):         QT += organizer
+dnl qtHaveModule(packetprotocol):    QT += packetprotocol
+qtHaveModule(platformheaders):   QT += platformheaders
+dnl qtHaveModule(positioning):       QT += positioning
 qtHaveModule(printsupport):      QT += printsupport
-qtHaveModule(qml):               QT += qml
-qtHaveModule(qmltest):           QT += qmltest
-qtHaveModule(x11extras):         QT += x11extras
-qtHaveModule(script):            QT += script
-qtHaveModule(scripttools):       QT += scripttools
-qtHaveModule(sensors):           QT += sensors
-qtHaveModule(serialport):        QT += serialport
-qtHaveModule(sql):               QT += sql
+dnl qtHaveModule(qml):               QT += qml
+dnl qtHaveModule(qmldebug):          QT += qmldebug
+dnl qtHaveModule(qmldevtools):       QT += qmldevtools
+dnl qtHaveModule(qmltest):           QT += qmltest
+dnl qtHaveModule(qprinter):          QT += qprinter
+dnl qtHaveModule(quick):             QT += quick
+dnl qtHaveModule(quickparticles):    QT += quickparticles
+dnl qtHaveModule(quicktest):         QT += quicktest
+dnl qtHaveModule(quickwidgets):      QT += quickwidgets
+dnl qtHaveModule(script):            QT += script
+dnl qtHaveModule(scripttools):       QT += scripttools
+dnl qtHaveModule(sensors):           QT += sensors
+dnl qtHaveModule(serialport):        QT += serialport
+dnl qtHaveModule(sql):               QT += sql
 qtHaveModule(svg):               QT += svg
-qtHaveModule(testlib):           QT += testlib
-qtHaveModule(uitools):           QT += uitools
+dnl qtHaveModule(test):              QT += test
+dnl qtHaveModule(testlib):           QT += testlib
+dnl qtHaveModule(uitools):           QT += uitools
+dnl qtHaveModule(versit):            QT += versit
+dnl qtHaveModule(versitorganizer):   QT += versitorganizer
+qtHaveModule(webchannel):        QT += webchannel
 qtHaveModule(webkit):            QT += webkit
-qtHaveModule(webkitwidgets):     QT += webkitwidgets
-qtHaveModule(xml):               QT += xml
-qtHaveModule(xmlpatterns):       QT += xmlpatterns
+dnl qtHaveModule(webkitwidgets):     QT += webkitwidgets
+qtHaveModule(widgets):           QT += widgets
+qtHaveModule(x11extras):         QT += x11extras
+dnl qtHaveModule(xml):               QT += xml
+dnl qtHaveModule(xmlpatterns):       QT += xmlpatterns
 percent.target = %
 percent.commands = @echo -n "\$(\$(@))\ "
 QMAKE_EXTRA_TARGETS += percent
 EOF
     qmake $am_have_qt_pro -o $am_have_qt_makefile
-    QT_CXXFLAGS=`cd $(dirname  $am_have_qt_makefile ); make -f $am_have_qt_makefile CXXFLAGS INCPATH`
-    QT_LIBS=`cd $(dirname  $am_have_qt_makefile ); make -f $am_have_qt_makefile LIBS`
+    QT_CXXFLAGS=`make -s -f $am_have_qt_makefile CXXFLAGS INCPATH`
+    QT_LIBS=`make -s -f $am_have_qt_makefile LIBS`
     rm $am_have_qt_pro $am_have_qt_makefile
 
     # Look for specific tools in $PATH
diff --git a/src/misc/m4/tm_gui.m4 b/src/misc/m4/tm_gui.m4
index 801876070..75692420d 100644
--- a/src/misc/m4/tm_gui.m4
+++ b/src/misc/m4/tm_gui.m4
@@ -50,15 +50,15 @@ AC_DEFUN([TM_GUI],[
   esac
 
   # Qt Plugins list
-  PLUGINS_LIST="imageformats,accessible"
+  PLUGINS_LIST="imageformats,accessible,accessiblebridge,inputmethods"
   if test "$QT5_AVAILABLE" = yes; then
-    PLUGINS_LIST="imageformats"
+     PLUGINS_LIST="generic,imageformats,platforminputcontexts,platforms,printsupport,xcbglintegrations"
   fi
-  #define([PLUGINS_LIST],[imageformats,accessible])
   QT_PLUGINS_LIST="$PLUGINS_LIST"
   AC_ARG_ENABLE(QtPlugins,
 	 AS_HELP_STRING([--enable-QtPlugins@<:@=list@:>@],
-		  [defaults plugins: imageformats, and possibly more]),
+		  [default qt4 plugins: imageformats,accessible,accessiblebridge,inputmethods
+default qt5 plugins: generic,imageformats,platforminputcontexts,platforms,printsupport,xcbglintegrations]),
     [QT_PLUGINS_LIST=$enableval],[QT_PLUGINS_LIST="$PLUGINS_LIST"])
   case $QT_PLUGINS_LIST in
   yes) QT_PLUGINS_LIST="$PLUGINS_LIST";;
diff --git a/src/packages/debian/rules b/src/packages/debian/rules
index 4cf08f514..57138470d 100755
--- a/src/packages/debian/rules
+++ b/src/packages/debian/rules
@@ -9,5 +9,17 @@
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
 
+export DH_ALWAYS_EXCLUDE=.git
+
+DEB_CONFIGURE_OPTIONS :=
+	'--enable-QtPlugins=generic,imageformats,platforminputcontexts,platforms,printsupport,xcbglintegrations,styles,iconengines,platformthemes' \
+	'--enable-optimize="-O3 -fexpensive-optimizations -fPIC"'
+
+#	'--enable-QtPlugins=generic,imageformats,platforminputcontexts,platforms,printsupport,xcbglintegrations,styles,iconengines,platformthemes,wayland-decoration-client,wayland-graphics-integration-client,wayland-shell-integration'
+
+
 %:
-	dh --parallel $@ 
+	dh --parallel $@
+
+override_dh_auto_configure:
+	dh_auto_configure -- $(DEB_CONFIGURE_OPTIONS)
